from django.db import models
from datetime import *

# Create your models here.

virtuall_wiki_views = "virtuall_wiki_views"
virtuall_wiki_edits = "virtuall_wiki_edits"

def getActivities(name):
	loc = Location.objects.filter(description=name)
	return Activity.objects.filter(location=loc[0].id)

def getAvgActivity(locName, start, end):
	loc = Location.objects.filter(description=locName)
	act = Activity.objects.filter(location=loc[0].id, timestamp__gte=start, timestamp__lte = end)
	
	sum = 0.0
	for a in act:
		sum += a.activity
	if len(act) != 0:
		return sum / len(act)
	else:
		return None
		
def getLastActivity(locName):
	loc = Location.objects.get(description=locName)
	moment_ago = datetime.now()-timedelta(minutes=5)
	lockActivities = Activity.objects.filter(timestamp__gte=moment_ago, location=loc.id).order_by('timestamp')
	if len(lockActivities) == 0:
		return None
	else:
		return lockActivities[len(lockActivities)-1].activity

class Location(models.Model):
    description = models.CharField(maxlength=200)

    class Admin:
        pass

    def __str__(self):
        return "%d: %s" % (self.id, self.description)
    

class Activity(models.Model):
    location = models.ForeignKey(Location)
    activity = models.IntegerField('activity percentage')
    timestamp = models.DateTimeField('activity timestamp')

    class Admin:
        pass
    
    def __str__(self):
        return "%s %d" % (str(self.timestamp), self.activity)
