import os
os.environ['DJANGO_SETTINGS_MODULE'] = "metastate.settings"
#import metastate
import sys
sys.path.append("/home/wizard23/metasense")

from metastate.activity.models import *
import time
from datetime import datetime, timedelta
from pychart import *
from time_offset import time_correct

def get_seconds(dt):
    return time.mktime(dt.timetuple())

def format_date(t):
    return "/a10{}"+datetime.fromtimestamp(t).strftime('%H:%M')

def day_plot(dbName, niceName, fileName, ytic=20, yrange=None, offset=0, mul=1, dataWidth=1, missings=True):
	now = datetime.now()
	#now = now - timedelta(minutes=now.min, seconds=now.second)
	yesterday = now-timedelta(days=1, minutes=now.minute, seconds=now.second)
	dbLoc = Location.objects.get(description=dbName)
	recentActivities = Activity.objects.filter(timestamp__gte=yesterday, location=dbLoc.id).order_by('timestamp')

	missingData = []
	plotData = []
	timePos = yesterday
	maxErr = 300
	
	for a in recentActivities:
		plotData.append((get_seconds(a.timestamp), a.activity*mul + offset))
		x = a.timestamp - timePos
		
		while x.seconds > maxErr or x.days > 0:
			missingData.append((get_seconds(timePos), 255))
			timePos += timedelta(seconds=maxErr)
			x = a.timestamp - timePos
			
		timePos = a.timestamp
		
	x = now - timePos
	while x.seconds > maxErr or x.days > 0:
		missingData.append((get_seconds(timePos), 255))
		timePos += timedelta(seconds=maxErr)
		x = now - timePos
		#print "%d %d \n" % (x.days, x.seconds)

	print "Plotting %s with %d data points and %d missings" % (niceName, len(plotData), len(missingData))

	dateFormat = '%Y.%m.%d %H:%M'
	xlabel = "%s: %s - %s" % (niceName, yesterday.strftime(dateFormat), now.strftime(dateFormat))
	xaxis = axis.X(label=xlabel, tic_interval=3600, format=format_date)
	yaxis = axis.Y(label="Nerd Activity", tic_interval = ytic)
	ar = area.T(size=(800, 80), legend=None, x_axis=xaxis, y_axis=yaxis, y_range=(0, yrange), x_range=(get_seconds(yesterday), get_seconds(now)))
	
	
	anyPlot = False
	#fill_style.T(
	#color.T(r=1, g=0, b=1)
	if len(missingData) > 0 and missings:
		plot = bar_plot.T(label=None, data=missingData, width = 3, fill_style=fill_style.yellow, line_style=None)
		ar.add_plot(plot)
		anyPlot = True
	
	if len(plotData) > 0:
		plot = bar_plot.T(label=None, data=plotData, width=1, fill_style = None) #fill_style.green)
		ar.add_plot(plot)
		anyPlot = True
	
	
	if anyPlot:
		can = canvas.init("/var/www/kybernet.org/wizard23/metasense/%s" % fileName, "png")
		ar.draw(can)
		can.close()
	


webdir = "/var/www/kybernet.org/wizard23/metasense/"
webDirMetalab = "/var/www/metalab.at/metasense"


def update_status_led():
	loc_lock = Location.objects.get(description="door_lock")
	moment_ago = datetime.now()-timedelta(minutes=5)
	lockActivities = Activity.objects.filter(timestamp__gte=moment_ago, location=loc_lock.id).order_by('timestamp')
	f_lock = file("%s/status_lock.txt" % webDirMetalab, "w")
	
	if len(lockActivities) == 0:
		f_lock.write("X")
		os.system("cp %simages/yel_led.gif %smetalab_lock.gif" % (webdir, webdir))
		os.system("cp %s/not_connected.txt %s/status.txt" % (webDirMetalab, webDirMetalab))
	elif lockActivities[len(lockActivities)-1].activity == 0:
		f_lock.write("1")
		os.system("cp %simages/grn_led.gif %smetalab_lock.gif" % (webdir, webdir))
		os.system("cp %s/open.txt %s/status.txt" % (webDirMetalab, webDirMetalab))
	else:
		f_lock.write("0")
		os.system("cp %simages/red_led.gif  %smetalab_lock.gif" % (webdir, webdir))
		os.system("cp %s/not_open.txt %s/status.txt" % (webDirMetalab, webDirMetalab))
	f_lock.close()
	
	f_main_move = file("%s/status_mainroom_move1.txt" % webDirMetalab, "w")
	now = datetime.now()
	vorher = now-timedelta(minutes=10)    
	act = getLastActivity("mainroom_move1") 
	if act == None:
		act = 'X'
	f_main_move.write(str(act))
	f_main_move.close()
	
		
		

update_status_led()
day_plot("mainroom_move1", "Main Room Movement", "metalab_activity.png", yrange=100)
day_plot("door_lock", "Lock Status", "metalab_lock_activity.png", 128, offset=255, mul=-1)
day_plot("kitchen_move", "Kitchen Movement", "metalab_kitchen_activity.png", yrange=100)

day_plot(virtuall_wiki_views, "Wiki Views", "%s_activity.png" % virtuall_wiki_views, ytic=5, yrange=20, missings=False)
day_plot(virtuall_wiki_edits, "Wiki Edits", "%s_activity.png" % virtuall_wiki_edits, ytic=5, yrange=10, missings=False) 
    
