import os
os.environ['DJANGO_SETTINGS_MODULE'] = "metastate.settings"
#import metastate
import sys
sys.path.append("/home/wizard23/metasense")

from metastate.activity.models import *
import time
from datetime import datetime, timedelta
from pychart import *
from time_offset import time_correct

webDir = "/var/www/kybernet.org/wizard23/metasense"

def get_seconds(dt):
    return time.mktime(dt.timetuple())

def format_date(t):
    return "/a10{}"+datetime.fromtimestamp(t).strftime('%H:%M')

def avg_plot(dbName, dbDate, niceName, fileName, days=10, ytic=20, yrange=None, offset=0, mul=1):
	timeSlots = []
	timeSlotsCount = []
	slots = 240/2
	
	niceName += " average last %d days" % days
	
	for i in range(0, slots+1):
		timeSlots.append(0)
		timeSlotsCount.append(0)
	
	oneDay = timedelta(days = 1)
	slotLen = oneDay / slots
	
	for currentDay in range(-days, 1):
		start = dbDate + oneDay*currentDay 
		end = start + oneDay
	
		startSec = get_seconds(start)
		endSec = get_seconds(end)
		intervalLen = endSec - startSec
	
		dbLoc = Location.objects.get(description=dbName)
		activities = Activity.objects.filter(timestamp__gte=start, timestamp__lte=end, location=dbLoc.id).order_by('timestamp')
	
		print "day: %d activities: %d" % (currentDay, len(activities))
		
		for a in activities:
			idx = int(((get_seconds(a.timestamp) - startSec)*slots) / intervalLen)
			timeSlots[idx] += mul * a.activity + offset
			timeSlotsCount[idx] += 1
		
	plotData = []
	print timeSlots
	print timeSlotsCount
	
	currentDate = start
	for idx in range(0, slots):
		if timeSlotsCount[idx] > 0:
			plotData.append((get_seconds(currentDate), timeSlots[idx]/timeSlotsCount[idx]))
		else:
			plotData.append((get_seconds(currentDate), 0))
		currentDate += slotLen
		
	print "Plotting average %s for the last %d days" % (niceName, days)

	dateFormat = '%Y.%m.%d'
	xlabel = "%s: %s - %s" % (niceName, (dbDate-days*oneDay).strftime(dateFormat), dbDate.strftime(dateFormat))
	xaxis = axis.X(label=xlabel, tic_interval=3600, format=format_date)
	yaxis = axis.Y(label="Nerd Activity", tic_interval = ytic)
	ar = area.T(size=(800, 80), legend=None, x_axis=xaxis, y_axis=yaxis, y_range=(0, yrange), x_range=(get_seconds(start), get_seconds(end)))
	
	if len(plotData) > 0:
		plot = bar_plot.T(label=None, data=plotData, width=4, fill_style = fill_style.black) #fill_style.green)
		ar.add_plot(plot)
	
	can = canvas.init("/var/www/kybernet.org/wizard23/metasense/%s" % fileName, "png")
	ar.draw(can)
	can.close()

if __name__ == '__main__':
	now =  datetime.now()
	startOfToday = now-timedelta(hours=now.hour, minutes=now.minute, seconds=now.second)
	avg_plot("mainroom_move1", startOfToday, "Main Room Movement", "metalab_activity_avg.png", days=7, yrange=30)
	avg_plot("door_lock", startOfToday, "LockStatus", "metalab_lock_activity_avg.png", days=7, ytic=256, yrange=256, offset=255, mul=-1)
	avg_plot("kitchen_move", startOfToday, "Kitchen Movement", "metalab_kitchen_activity_avg.png", days=7, yrange=20)
	
	avg_plot(virtuall_wiki_views, startOfToday, "Wiki Views", "%s_activity_avg.png" % virtuall_wiki_views, days=7, ytic=5, yrange=20)
	avg_plot(virtuall_wiki_edits, startOfToday, "Wiki Edits", "%s_activity_avg.png" % virtuall_wiki_edits, days=7, ytic=5, yrange=10)
